from PIL import Image, ImageColor

src = Image.open("src.png").convert("RGB")

colours = sorted([i[1] for i in src.getcolors()], key = lambda x: sum(x))

num_screens = len(colours) - 1

pattern = []

for i in range(len(colours)):
    pattern.append([0] * num_screens)
    
    for j in range(i):
        index = (j * 2) % num_screens
        
        if j * 2 >= num_screens:
            index += 1 - num_screens % 2
            
        pattern[i][index] = 1

dests = [Image.new("1", (96, 64)) for i in range(num_screens)]

for screen in range(num_screens):
    for i in range(src.size[0]):
        for j in range(src.size[1]):
            pixel_colour = src.getpixel((i, j))
            colour_index = colours.index(pixel_colour)
            pattern_pixel = pattern[colour_index][(i + j + screen) % num_screens]
            
            dests[screen].putpixel((i, j), pattern_pixel)

for i in range(num_screens):
    dests[i].save("screen{}.png".format(i + 1))