#include <pm.h>
#include <stdint.h>

#include "screens.h"

void copy_image_gddram(const _rom uint8_t * data);

_inline void wait_vsync_cont(void)
{
	while(PRC_CONT != 0x10);
}

volatile uint8_t frame = 0;

void _interrupt(3) timer_8hz_irq(void) {
	IRQ_ACT2 |= IRQ2_8HZ;
	if(++frame >= ANIM_FRAMES << 1)	frame = 0;
}

void main(void)
{
	uint16_t index = 0;

	PRC_MODE = 0;
	
	IRQ_ENA3 = IRQ3_KEYPOWER;
	
	IRQ_ENA2 = IRQ2_8HZ;
	IRQ_PRI2 = PRI2_KEY(3) | PRI2_TIM256(1);
	
	TMR256_CTRL |= 1;
	
	while(1)
	{
		wait_vsync_cont();
		copy_image_gddram(screens[frame >> 1] + index);
		if((index += SCREEN_SIZE) >= SCREENS_LEN * SCREEN_SIZE)	index = 0;
	}
}